class ApplicationController < ActionController::Base
  # Prevent CSRF attacks by raising an exception.
  # For APIs, you may want to use :null_session instead.
  protect_from_forgery with: :exception

  before_filter :profiler_check

  helper :all

  protected

  def profiler_check
    if params[:profile].present?
      Rack::MiniProfiler.authorize_request
    end
  end

  def after_sign_in_path_for(resource_or_scope)
    session.fetch 'user_return_to', '/'
  end
end
