class AttachmentsController <  ApplicationController
  before_filter :authenticate_user!

  def show
    attachment = Attachment.find params[:id]

    send_data attachment.file_data,
      type:         attachment.content_type,
      filename:     attachment.filename,
      disposition:  'inline'
  end

  def upload
    @attachment = Attachment.find params[:id]
    @attachment.update(params[:file], current_user)
  end

  def destroy
    @attachment = Attachment.find params[:id]
    @attachment.save_and_destroy(current_user)

    render json: {}
  end
end
