class CommentsController < ApplicationController
  before_filter :authenticate_user!

  def create
    @comment = Comment.new(
      comment_params.merge(user: current_user)
    )
    if @comment.save
      @ticket = @comment.ticket
      @activity = @ticket.create_activity key: "ticket.create_comment", owner: current_user, recipient: @comment
    end

    respond_to do |format|
      format.js
    end
  end

  private

  def comment_params
    params.require(:comment).permit(:body, :ticket_id)
  end
end

