class Work::UsersController < ApplicationController
  before_filter :authenticate_user!

  def index
    @users = User.all
  end

  def new
    @user = User.new
  end

  def create
    @user = User.create(params.require(:user).permit(:name, :email, :password))

    if @user.errors.any?
      render :new
    else
      redirect_to work_users_path
    end
  end

  def reset_password_email
    user = User.find(params[:id])
    user.send_reset_password_instructions
    flash[:notice] = "Reset password instructions have been sent to #{user.email}."
    redirect_to work_users_path
  end
end
