module Tawork
  module ApplicationHelper
    [:project, :story, :bug, :task].each do |method|
      define_method("#{method}_path") do |*args|
        ticket_path(*args)
      end

      define_method("#{method.to_s.pluralize}_path") do |*args|
        tickets_path(*args)
      end
    end

    def ticket_types
      Ticket::ALLOWED_TYPES.each_with_object({}) do |type, hash|
        hash[type] = Ticket.filtered_type_class(type).new(
          creator: current_user,
          parent_id: params[:parent_id]
        )
      end
    end

    def title(page_title)
      content_for(:title) { page_title }
      page_title
    end

    def icon_for(thing)
      case thing
      when Space
        icon = "bullseye"
      when Page
        icon = "file"
      when Attachment
        icon = "paperclip"
      end

      tag(:i, class: "fa fa-#{icon}")
    end

    def body_layout
      if params[:controller] == "wiki/pages" && params[:action] == "compare"
        return "layouts/compare_layout"
      end

      "layouts/default_layout"
    end
  end
end
