class Story < Ticket
  has_one :story_detail, foreign_key: "ticket_id", dependent: :destroy

  validates :who, :what, presence: true

  after_save do 
    story_detail.save if story_detail.changed?
  end

  [:who, :what, :why].each do |method|
    define_method(method) do |*args|
      return nil unless story_detail
      story_detail.send(method, *args)
    end

    define_method("#{method}=") do |*args|
      build_story_detail unless story_detail
      story_detail.send("#{method}=", *args)
    end
  end

  def title
    return super unless who.present? && what.present?
    title = "#{who} wants to #{what}"
    title += ", so: #{why}" if why.present?

    title
  end
end
