# encoding: UTF-8
# This file is auto-generated from the current state of the database. Instead
# of editing this file, please use the migrations feature of Active Record to
# incrementally modify your database, and then regenerate this schema definition.
#
# Note that this schema.rb definition is the authoritative source for your
# database schema. If you need to create the application database on another
# system, you should be using db:schema:load, not running all the migrations
# from scratch. The latter is a flawed and unsustainable approach (the more migrations
# you'll amass, the slower it'll run and the greater likelihood for issues).
#
# It's strongly recommended that you check this file into your version control system.

ActiveRecord::Schema.define(version: 20140324124211) do

  create_table "activities", force: true do |t|
    t.integer  "trackable_id"
    t.string   "trackable_type"
    t.integer  "owner_id"
    t.string   "owner_type"
    t.string   "key"
    t.text     "parameters"
    t.integer  "recipient_id"
    t.string   "recipient_type"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  add_index "activities", ["owner_id", "owner_type"], name: "index_activities_on_owner_id_and_owner_type", using: :btree
  add_index "activities", ["recipient_id", "recipient_type"], name: "index_activities_on_recipient_id_and_recipient_type", using: :btree
  add_index "activities", ["trackable_id", "trackable_type"], name: "index_activities_on_trackable_id_and_trackable_type", using: :btree

  create_table "assignments", force: true do |t|
    t.integer  "user_id"
    t.integer  "ticket_id"
    t.integer  "priority"
    t.integer  "assigner_id"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  add_index "assignments", ["assigner_id"], name: "index_assignments_on_assigner_id", using: :btree
  add_index "assignments", ["ticket_id"], name: "index_assignments_on_ticket_id", using: :btree
  add_index "assignments", ["user_id"], name: "index_assignments_on_user_id", using: :btree

  create_table "attachments", force: true do |t|
    t.string   "filename"
    t.string   "content_type"
    t.integer  "size"
    t.string   "attachable_type"
    t.integer  "attachable_id"
    t.datetime "created_at"
    t.datetime "updated_at"
    t.integer  "version_count",                      default: 1
    t.text     "extracted_text",  limit: 2147483647
  end

  create_table "comments", force: true do |t|
    t.integer  "user_id"
    t.integer  "ticket_id"
    t.text     "body"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  add_index "comments", ["ticket_id"], name: "index_comments_on_ticket_id", using: :btree
  add_index "comments", ["user_id"], name: "index_comments_on_user_id", using: :btree

  create_table "deleted_items", force: true do |t|
    t.string   "item_type"
    t.integer  "item_id"
    t.text     "yaml",          limit: 2147483647
    t.text     "json",          limit: 2147483647
    t.integer  "deleted_by_id"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "pages", force: true do |t|
    t.string   "type"
    t.string   "ancestry"
    t.string   "title"
    t.text     "body",       limit: 2147483647
    t.integer  "creator_id"
    t.integer  "position",                      default: 1000
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  add_index "pages", ["creator_id"], name: "index_pages_on_creator_id", using: :btree

  create_table "starreds", force: true do |t|
    t.integer  "starrable_id"
    t.string   "starrable_type"
    t.integer  "user_id"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  add_index "starreds", ["user_id"], name: "index_starreds_on_user_id", using: :btree

  create_table "story_details", force: true do |t|
    t.integer  "ticket_id"
    t.string   "who"
    t.string   "what"
    t.string   "why"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  add_index "story_details", ["ticket_id"], name: "index_story_details_on_ticket_id", using: :btree

  create_table "taggings", force: true do |t|
    t.integer  "tag_id"
    t.integer  "taggable_id"
    t.string   "taggable_type"
    t.integer  "tagger_id"
    t.string   "tagger_type"
    t.string   "context",       limit: 128
    t.datetime "created_at"
  end

  add_index "taggings", ["tag_id", "taggable_id", "taggable_type", "context", "tagger_id", "tagger_type"], name: "taggings_idx", unique: true, using: :btree

  create_table "tags", force: true do |t|
    t.string "name"
  end

  add_index "tags", ["name"], name: "index_tags_on_name", unique: true, using: :btree

  create_table "tickets", force: true do |t|
    t.string   "state"
    t.string   "type"
    t.string   "ancestry"
    t.string   "title"
    t.text     "description"
    t.datetime "created_at"
    t.datetime "updated_at"
    t.integer  "creator_id"
    t.integer  "position",    default: 1000
  end

  add_index "tickets", ["creator_id"], name: "index_tickets_on_creator_id", using: :btree

  create_table "users", force: true do |t|
    t.string   "email",                  default: "", null: false
    t.string   "encrypted_password",     default: "", null: false
    t.string   "reset_password_token"
    t.datetime "reset_password_sent_at"
    t.datetime "remember_created_at"
    t.integer  "sign_in_count",          default: 0,  null: false
    t.datetime "current_sign_in_at"
    t.datetime "last_sign_in_at"
    t.string   "current_sign_in_ip"
    t.string   "last_sign_in_ip"
    t.datetime "created_at"
    t.datetime "updated_at"
    t.string   "username"
    t.string   "name"
  end

  add_index "users", ["email"], name: "index_users_on_email", unique: true, using: :btree
  add_index "users", ["reset_password_token"], name: "index_users_on_reset_password_token", unique: true, using: :btree

end
