require 'public_activity/models/activity'

module PublicActivity
  class Activity
    def trackable
      track = super
      track = DeletedTrackable.new(self) if !track

      track
    end
  end

  class DeletedTrackable
    def initialize(activity)
      @activity = activity
    end

    def id
      @activity.trackable_id
    end

    def to_param
      ["deleted", @activity.trackable_id].join("-")
    end

    def title
      "[Deleted #{@activity.trackable_type}]"
    end
  end
end
